/*
	Open device files and initialize variables
*/

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "func_extern.h"
#include "uss.h"

int initialize(){

	int i;

        printf("Initialization\n");

	/*
	Open the device files.
	irs_ts_ws and irs_code devices are not open here but will be 
	open in functions.
	*/
  
        if ((fd0 = open("/dev/rtf2", O_RDONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf2\n");
                exit(1);
        }
        if ((fd1 = open("/dev/rtf3", O_RDONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf3\n");
                exit(1);
        }
        if ((fd2 = open("/dev/rtf4", O_WRONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf4\n");
                exit(1);
        }
        if ((fd3 = open("/dev/rtf5", O_WRONLY)) < 0) {
               fprintf(stderr, "Error opening /dev/rtf5\n");
               exit(1);
        }
        //if ((fd4 = open("/dev/irs_ts_ws", O_RDONLY)) < 0) {
        //        fprintf(stderr, "Error opening /dev/irs_ts_ws\n");
        //        exit(1);
        //}
        if ((fd5 = open("/dev/lcd", O_RDWR)) < 0) {
                fprintf(stderr, "Error opening /dev/lcd\n");
                exit(1);
        }
        //if ((fd6 = open("/dev/irs_code", O_RDWR)) < 0) {
        //        fprintf(stderr, "Error opening /dev/irs_code\n");
        //        exit(1);
        //}
        if ((ctl = open("/dev/rtf1", O_WRONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf1\n");
                exit(1);
        }


        //Specify pthread_attribution

        pthread_attr_init (&attr_irs_ts_ws);
        sched_param.sched_priority = 20;
        pthread_attr_setschedpolicy(&attr_irs_ts_ws, SCHED_RR);
        pthread_attr_setschedparam (&attr_irs_ts_ws, &sched_param);

        pthread_attr_init (&attr_encoder);
        sched_param.sched_priority = 20;
        pthread_attr_setschedpolicy(&attr_encoder, SCHED_RR);
        pthread_attr_setschedparam (&attr_encoder, &sched_param);

        pthread_attr_init (&attr_uss);
        sched_param.sched_priority = 20;
        pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
        pthread_attr_setschedparam (&attr_uss, &sched_param);

        pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws, &irs_ts_ws, (void *)1);
        pthread_create(&encoder_task, &attr_encoder, &encoder, (void *)1);
        //pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);
        //pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);

	// Initialize post data
	for(i=0;i<10;i++){
		post.ang[i]=0;
		post.dis[i]=0;
		post.got_post[i]=0;
		post.code[i]=0;
	}
	post.got_code=0;
	post.got_number=0;
	post.number=0;
	for(i=0;i<10;i++){
		post_tmp.ang[i]=0;
		post_tmp.dis[i]=0;
	}

	for(i=0;i<4;i++){
		irs[i] = '0';
		ts[i] = '0';
		ws[i] = '0';
	}

	irs_flag=0;
	ts_flag=0;
	ws_flag=0;
	uss_data=0;

	return 0;
}

