/*************************************************************
*     encoder2.c  Encoder reading  Ver.1.0                   *
*                                          Date:14 May 2004  *
*                                Programed by Hiroki.Segawa  *
*************************************************************/

/*************************************************************
*       This Source file contains these function.            *
*                                                            *
* void encoder_data(float *,float *,int *);                  *
*                                                            *
*  This function is read encoder count from fifo and         *
* calculation of rotated angle.                              *
**************************************************************/

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "pwm_enc.h"

void encoder_data2(float *l_distance, float *r_distance, int *br){
	fd_set rfds;
	struct timeval tv;
	struct count_data count;
	int retval1, retval2;
	int fd1 = 0; 
	// FIFO Open
	if((fd1 = open("/dev/rtf3", O_RDONLY)) < 0){
		fprintf(stderr, "Error opening /dev/rtf3\n");
		return;
	}
	// Read from FIFO
	FD_ZERO(&rfds);
	FD_SET(fd1, &rfds);
	tv.tv_sec = 0;
	tv.tv_usec = 100000; // Reading Period=100ms
	retval1 = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
	if(retval1 > 0){
		while(1){
			read(fd1, &count, sizeof(count)); // Read from FIFO
			retval2 = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
			if(retval2 == 0) break;
		}
	}
	// count.left_sum count.right_sum is encoder count pulse
	// calculation of rotation angle
	*l_distance = 1.0*count.left_sum * 360 / (cpr * gear);
	*r_distance = 1.0*count.right_sum * 360 / (cpr * gear);
	*br = count.br; // end flag.if br=1,control ended
	close(fd1);
}