#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "uss.h"

int uss_data;


void *uss_transmit(int *uss_no)
{
        struct timeval tv;
        struct uss_msg_struct uss_msg;

	int cmd;
	int n;
        fd_set rfds;
        int retval;
        int fd0, ctl;
	int bufsize=10;
	int buf[bufsize];

        //uss_msg.command=1; /* Shot */
        uss_msg.command=2; /* thread task */
        uss_msg.number=*uss_no;
	uss_msg.period=50;
        cmd = *uss_no;

	//printf("uss_no =%d\n",cmd);

        if ((fd0 = open("/dev/rtf2", O_RDONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf2\n");
                exit(1);
        }

        if ((ctl = open("/dev/rtf1", O_WRONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf1\n");
                exit(1);
        }

        if (write(ctl, &uss_msg, sizeof(uss_msg)) < 0){
                fprintf(stderr, "uss_transmit:now sending commands to uss%d.\n", cmd);
        }

        while(1) {
                        FD_ZERO(&rfds);
                        FD_SET(fd0, &rfds);
                        tv.tv_sec = 0;
                        tv.tv_usec = 100000;

                        retval = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
                        if (retval > 0) {
                                if (FD_ISSET(fd0, &rfds)) {
                                        n = read(fd0, buf, bufsize - 1);
                                        buf[n] = 0;
                                        uss_data = buf[0];
                                        break;
                                }
                        }
                        else {
                                uss_data = 999;
                                break;
                        }

        }
	close(fd0);
	close(ctl);
        pthread_exit(0);
}

int main()
{

        pthread_t uss_task;
        pthread_attr_t attr_uss;
	struct sched_param sched_param;


	int uss_no;
	int comand;
	int ret,i,j;

        pthread_attr_init (&attr_uss);
        sched_param.sched_priority = 21;
	pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
        pthread_attr_setschedparam(&attr_uss, &sched_param);

	comand = 1;
	//uss_no=1;

	//for(i=0;i<2;i++){
	while(1){
		for(j=3;j<4;j++){
			uss_no=j;	
        		ret=pthread_create( &uss_task, &attr_uss, (void*)uss_transmit, &uss_no);
			ret=pthread_join(uss_task,NULL);
			printf("uss[%d] = %d\n",uss_no,uss_data);
			usleep(500000);
		}
	}

	return 0;
}
